/* Test function types 

   Pointers flowing in aggregates should impose
   constraints on the aggregates as a whole.
*/

typedef int T;


void foo()
{
  T t;
  int i;
  i = t;
}

void bar() {}
void baz() {}

void moo() {}

void biff() {}
void piff() {}

void crank() {}
void spank() {}

void innie () {}
void minnie () {}

void g (void (*fptr)())
{
  fptr();
}

struct x {
  void (*pf)();
};

struct z {
  void (*pf[2])();
};

void (*ar1[1])() = { &foo };
void (*ar2[2])() = { &bar, &baz };

struct x x1 = { &moo };
struct x y11[2] = { &crank, &spank };
struct z z1 = { {&biff, &piff} };

int main(int argc, char **argv)
{


  /* D should be { foo bar baz moo biff piff spank crank g innie minnie } */
  (ar1[0])();

  /* D should be { bar baz moo biff piff spank crank g innie minnie } */
  (ar2[0])();

  /* D should be { moo biff piff spank crank g innie minnie } */
  x1.pf();

  /* D should be { biff piff spank crank g innie minnie } */
  z1.pf[1]();

  /* D should be { spank crank g innie minnie } */
  y11[1].pf();

  /* D should be { spank crank g innie minnie } */
  g(&innie);

  /* D should be { minnie } */
  g(minnie);

  return 0;
}
