/* Plain recursive functions...*/
void upd_foo(int i)
{
  printf("upd_foo\n");

  if (i > 0)
    upd_foo(i - 1);
}

void nonupd_foo(int i)
{
  printf("nonupd_foo\n");

  if (i > 0)
    nonupd_foo(i -1);
}

/* and mutually recursive functions */
float f2(float);
float f1(float x)
{
  printf("f1\n");

  if (x > 0)
    return f2(x - 1);
}
float f2(float x)
{
  printf("f2\n");
  
  if (x > 0)
    return f1(x - 1);
}

int main(int argc, char **argv)
{
  void (*pf)(int) = & nonupd_foo;
  float (*pff1)(float) = & f1;
  float (*pff2)(float) = & f2;
  
  upd_foo(3);

  (*pf)(3);

  (*pff1)(3.14);
  (*pff2)(3.14);

  printf("end main.\n");

  return 0;
}
