# 1 "linkedlist.patch.c"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "linkedlist.patch.c"
# 214 "/usr/lib/gcc/i386-redhat-linux/4.1.1/include/stddef.h"
typedef unsigned int size_t;
# 16 "linkedlist-2.c"
struct T {
   int x ;
   int y ;
};
# 32 "linkedlist-2.c"
struct Tlist {
   struct T item ;
   struct Tlist *next ;
   struct Tlist *prev ;
};
# 1 "cil-hsov3Z0x.o"
#pragma merger(0,"/tmp/cil-rLXK23TD.i","")
# 6 "linkedlist-2.c"
#pragma __DSU_malloc("malloc")
struct my__DSU_loop_MAINLOOP_state {
   struct Tlist **pl ;
   struct T *t ;
   int *i ;
};
# 339 "/usr/include/stdio.h"
extern int printf(char const * __restrict __format , ...) ;
# 589 "/usr/include/stdlib.h"
extern __attribute__((__nothrow__)) void *malloc(size_t __size ) __attribute__((__malloc__)) ;
# 21 "linkedlist-2.c"
extern void printT(struct T *pt ) ;
# 39 "linkedlist-2.c"
struct Tlist *consT(struct T *pt , struct Tlist *pl )
{ struct Tlist *l ;
  struct Tlist *tmp ;

  {
  {
# 41 "linkedlist-2.c"
  tmp = (struct Tlist *)malloc(sizeof(struct Tlist ));
# 41 "linkedlist-2.c"
  l = tmp;
# 42 "linkedlist-2.c"
  l->next = pl;
# 43 "linkedlist-2.c"
  l->prev = (struct Tlist *)0;
# 44 "linkedlist-2.c"
  pl->prev = l;
# 45 "linkedlist-2.c"
  l->item = (*pt);
  }
# 47 "linkedlist-2.c"
  return (l);
}
}
# 50 "linkedlist-2.c"
void iterT(void (*f)(struct T * ) , struct Tlist *pl )
{

  {
  {
# 52 "linkedlist-2.c"
  while (1) {
# 52 "linkedlist-2.c"
    if (! pl) {
      goto while_3_break;
    }
    {
# 54 "linkedlist-2.c"
    ((*f))(& pl->item);
# 55 "linkedlist-2.c"
    pl = pl->next;
    }
  }
  while_3_break: ;
  }
# 57 "linkedlist-2.c"
  return;
}
}
# 61 "linkedlist-2.c"
void revIterT(void (*f)(struct T * ) , struct Tlist *pl )
{

  {
  {
# 63 "linkedlist-2.c"
  while (1) {
# 63 "linkedlist-2.c"
    if (! pl) {
      goto while_4_break;
    }
    {
# 65 "linkedlist-2.c"
    ((*f))(& pl->item);
# 66 "linkedlist-2.c"
    pl = pl->prev;
    }
  }
  while_4_break: ;
  }
# 68 "linkedlist-2.c"
  return;
}
}
# 72 "linkedlist-2.c"
struct Tlist *lastT(struct Tlist *pl )
{

  {
  {
# 74 "linkedlist-2.c"
  while (1) {
# 74 "linkedlist-2.c"
    if (! pl->next) {
      goto while_5_break;
    }
# 76 "linkedlist-2.c"
    pl = pl->next;
  }
  while_5_break: ;
  }
# 78 "linkedlist-2.c"
  return (pl);
}
}
# 89 "linkedlist-2.c"
void interactive_update(struct Tlist *pl )
{ struct Tlist *tmp ;

  {
  {
# 91 "linkedlist-2.c"
  printf((char const * __restrict )"*** interactive_update version 2:  double linked list; list elements have two members, .x and .y; list should be printed in reverse\n");
# 92 "linkedlist-2.c"
  tmp = lastT(pl);
# 92 "linkedlist-2.c"
  revIterT(& printT, tmp);
  }
# 94 "linkedlist-2.c"
  return;
}
}
extern int __DSU__old_externglobal_version ;
# 96 "linkedlist-2.c"
int global_version = 2;
int my__DSU_loop_MAINLOOP(int *__loop_retval , struct my__DSU_loop_MAINLOOP_state *__loop_state_MAINLOOP )
{

  {

  {
# 113 "linkedlist-2.c"
  printf((char const * __restrict )"*** MAINLOOP: main() version 2, global_version = %d\n",
         global_version);
# 115 "linkedlist-2.c"
  interactive_update((*(__loop_state_MAINLOOP->pl)));
# 117 "linkedlist-2.c"
  (*(__loop_state_MAINLOOP->i)) = (*(__loop_state_MAINLOOP->i)) + 1;
  }
# 118 "linkedlist-2.c"
  if ((*(__loop_state_MAINLOOP->i)) >= 3) {
# 119 "linkedlist-2.c"
    return (0);
  }
# 112 "linkedlist-2.c"
  return (1);
}
}




#pragma __DSU_TT("tt_Tlist","struct_Tlist","struct_Tlist_old","struct_Tlist_new")
struct Tlist_old {
   struct T item ;
   struct Tlist *next ;
};
struct Tlist_new {
   struct T item ;
   struct Tlist *next ;
   struct Tlist *prev ;
};
void tt_Tlist(struct Tlist_old *xin , struct Tlist_new *xout , struct Tlist *xnew )
{

  {
  xout->item = xin->item;
  xout->next = xin->next;
  if (xout->next)
    xout->next->prev = xnew;
}
}
void __DSU_state_xform() {
  global_version = 2;
}
