struct S {
  int *x;
};

struct M {
  int *f;
};

struct M mvar = { (int *)0 }; /* will contain a suspect pointer to S */
struct S svar = {1};

extern int __DSU_update();

/* G,L == { S,typeof_gvar_svar }. S due to pollution via struct_M below */
void baz() {
  int *z = &(svar.x);
  /* pollute the global environment; all preconditions of called
     functions will have struct S */
  mvar.f = z;
}

/* L == { }, G == { S, typeof_gvar_svar } */
void main() {
  baz();
  /* update will contain { S } due to pollution */
  __DSU_update();
}

