#include "mapp.h"
#include <stdio.h>

int main(int argc, char ** argv)
{
  void * handle = mCreateMap();
  void * burrito = (void *) 0xDEADBEEF;

  mAdd (handle, "minnie", burrito);
  mAdd (handle, "innie", burrito);
  mAdd (handle, "miny", burrito);
  mAdd (handle, "moe", burrito);

  if (mFind(handle, "minnie") != NULL)
    printf("minnie test passed\n");
  else
    printf("minnie test failed\n");

  if (mFind(handle, "tiger") != NULL)
    printf("tiger test failed");
  else
    printf("tiger test passed\n");

  printf("removing miny...\n");

  mRemove(handle, "miny");

  if (mFind(handle, "miny") != NULL)
    printf("miny test failed\n");
  else
    printf("miny test passed\n");

  for(;;);

  mDeleteMap(handle);
            
  return 0;
}
