/* Test function types 

   Each function should have its name and the names of all its callees
   in the label set
*/


/* { foo } */
void foo()
{}

/* { bar } */
void bar()
{}

/* { baz } */
void baz()
{}

/* { bar baz bazaar } */
void bazaar()
{
  bar ();
  baz ();
}

extern moo();

void (*f1)() = &moo;
void (*f2)() = &foo;

/* { bar baz foo bazaar } 

   note that 'moo' shouldn't be in the label set since it's extern 
*/
int main(int argc, char **argv)
{
  void (*pf1)() = f1;
  void (*pf2)() = f2;

  /* { bar baz foo bazaar } */
  (*pf1)();
  /* { bar baz foo bazaar } */
  (*pf2)();
  /* { bar baz bazaar } */
  bazaar();
  /* { bar baz } */
  bar();
  /* { baz } */
  baz();
}
