struct passwd {int x;};
struct context {int y;};

struct fatal_cleanup {
   struct fatal_cleanup *next ;
   void (*proc)(void * ) ;
   void *context ;
};

static struct fatal_cleanup *fatal_cleanups  =    (struct fatal_cleanup *)((void *)0);

void fatal_add_cleanup(void (*proc)(void * ) , void *context ) 
{ struct fatal_cleanup *cu ;

  cu = (struct fatal_cleanup *)xmalloc(sizeof((*cu)));

  cu->proc = proc;

  cu->context = context;

  cu->next = fatal_cleanups;

  fatal_cleanups = cu;

  return;
}

static void cleanup_passwd(void *_pw ) 
{ 
  struct passwd *pw ;
  pw = (struct passwd *)_pw;
}

static void cleanup_context(void *_pc ) 
{ 
  struct context *pc ;
  pc = (struct context *)_pc;
}

void foo()
{  
  struct passwd *pw ;
  struct context *pc ;

  fatal_add_cleanup(& cleanup_passwd, (void *)pw);
  fatal_add_cleanup(& cleanup_context, (void *)pc);
}

void fatal_cleanup(void) 
{ struct fatal_cleanup *cu ;
  struct fatal_cleanup *next_cu ;

  cu = fatal_cleanups;
  ((*(cu->proc)))(cu->context);
}


int main(int argc, char ** argv)
{
  foo();
  fatal_cleanup();

  return 0;
}
