#include <stdlib.h>

struct S { int x; int y; };
struct S s = { 1,2 };
struct S *ps = &s;  /* all OK (S is updatable) */

struct T { int z; struct S *ps; };

/* struct_S is not-updatable during foo (inherited from bar) */
void foo() {
  return;
}

/* struct_S is not-updatable during bar */
void bar() {
  int *susp;
  struct T *t = malloc(sizeof(struct T));
  t->z = 1;
  t->ps = ps;
  susp = &t->ps->y; // should just make S suspect  
  foo();
}

void main() {
  /* no restrictions on what can be updated here */
  bar();
}
